// This file is part of Ghost Network.

// Ghost Network is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Ghost Network is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Ghost Network.  If not, see <http://www.gnu.org/licenses/>.

//! Autogenerated weights for `ghost_slow_clap`
//!
//! THIS FILE WAS AUTO-GENERATED USING THE SUBSTRATE BENCHMARK CLI VERSION 32.0.0
//! DATE: 2024-08-02, STEPS: `50`, REPEAT: `20`, LOW RANGE: `[]`, HIGH RANGE: `[]`
//! WORST CASE MAP SIZE: `1000000`
//! HOSTNAME: `ghostown`, CPU: `Intel(R) Core(TM) i3-2310M CPU @ 2.10GHz`
//! WASM-EXECUTION: `Compiled`, CHAIN: `Some("casper-dev")`, DB CACHE: 1024

// Executed Command:
// ./target/release/ghost
// benchmark
// pallet
// --chain=casper-dev
// --steps=50
// --repeat=20
// --pallet=ghost_slow_clap
// --extrinsic=*
// --wasm-execution=compiled
// --heap-pages=4096
// --header=./file_header.txt
// --output=./runtime/casper/src/weights/ghost_slow_clap.rs

#![cfg_attr(rustfmt, rustfmt_skip)]
#![allow(unused_parens)]
#![allow(unused_imports)]
#![allow(missing_docs)]

use frame_support::{traits::Get, weights::Weight};
use core::marker::PhantomData;

/// Weight functions for `ghost_slow_clap`.
pub struct WeightInfo<T>(PhantomData<T>);
impl<T: frame_system::Config> ghost_slow_clap::WeightInfo for WeightInfo<T> {
	/// Storage: `GhostSlowClaps::Authorities` (r:1 w:0)
	/// Proof: `GhostSlowClaps::Authorities` (`max_values`: Some(1), `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::AuthorityInfoInSession` (r:1 w:0)
	/// Proof: `GhostSlowClaps::AuthorityInfoInSession` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::ApplausesForTransaction` (r:1 w:0)
	/// Proof: `GhostSlowClaps::ApplausesForTransaction` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::ReceivedClaps` (r:1 w:0)
	/// Proof: `GhostSlowClaps::ReceivedClaps` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// The range of component `k` is `[1, 100]`.
	/// The range of component `j` is `[1, 20]`.
	fn slow_clap(k: u32, j: u32, ) -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `372 + j * (19 ±0)`
		//  Estimated: `3853 + j * (19 ±0)`
		// Minimum execution time: 95_459_000 picoseconds.
		Weight::from_parts(96_224_000, 0)
			.saturating_add(Weight::from_parts(0, 3853))
			// Standard Error: 152_014
			.saturating_add(Weight::from_parts(32_092_278, 0).saturating_mul(k.into()))
			// Standard Error: 761_228
			.saturating_add(Weight::from_parts(22_412_712, 0).saturating_mul(j.into()))
			.saturating_add(T::DbWeight::get().reads(4))
			.saturating_add(Weight::from_parts(0, 19).saturating_mul(j.into()))
	}
	/// Storage: `GhostSlowClaps::CurrentCompanionId` (r:1 w:1)
	/// Proof: `GhostSlowClaps::CurrentCompanionId` (`max_values`: Some(1), `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::Networks` (r:1 w:0)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::Companions` (r:0 w:1)
	/// Proof: `GhostSlowClaps::Companions` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::CompanionDetails` (r:0 w:1)
	/// Proof: `GhostSlowClaps::CompanionDetails` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn propose_companion() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `634`
		//  Estimated: `4099`
		// Minimum execution time: 167_770_000 picoseconds.
		Weight::from_parts(168_826_000, 0)
			.saturating_add(Weight::from_parts(0, 4099))
			.saturating_add(T::DbWeight::get().reads(2))
			.saturating_add(T::DbWeight::get().writes(3))
	}
	/// Storage: `GhostSlowClaps::Companions` (r:1 w:0)
	/// Proof: `GhostSlowClaps::Companions` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostNetworks::Networks` (r:1 w:0)
	/// Proof: `GhostNetworks::Networks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::CompanionDetails` (r:1 w:0)
	/// Proof: `GhostSlowClaps::CompanionDetails` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::ReleaseBlocks` (r:0 w:1)
	/// Proof: `GhostSlowClaps::ReleaseBlocks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn release_companion() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `839`
		//  Estimated: `4304`
		// Minimum execution time: 82_884_000 picoseconds.
		Weight::from_parts(84_135_000, 0)
			.saturating_add(Weight::from_parts(0, 4304))
			.saturating_add(T::DbWeight::get().reads(3))
			.saturating_add(T::DbWeight::get().writes(1))
	}
	/// Storage: `GhostSlowClaps::ReleaseBlocks` (r:1 w:0)
	/// Proof: `GhostSlowClaps::ReleaseBlocks` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::Companions` (r:1 w:1)
	/// Proof: `GhostSlowClaps::Companions` (`max_values`: None, `max_size`: None, mode: `Measured`)
	/// Storage: `GhostSlowClaps::CompanionDetails` (r:1 w:1)
	/// Proof: `GhostSlowClaps::CompanionDetails` (`max_values`: None, `max_size`: None, mode: `Measured`)
	fn kill_companion() -> Weight {
		// Proof Size summary in bytes:
		//  Measured:  `514`
		//  Estimated: `3979`
		// Minimum execution time: 152_418_000 picoseconds.
		Weight::from_parts(153_436_000, 0)
			.saturating_add(Weight::from_parts(0, 3979))
			.saturating_add(T::DbWeight::get().reads(3))
			.saturating_add(T::DbWeight::get().writes(2))
	}
}
